package cz.muni.fi.pb162.graphics;

public class Polygon extends AbstractGrObject
{
    private Point[] points;
 
    public Polygon(String color, Point[] points) {
        super(color);
        
        if (points == null) {
            throw new IllegalArgumentException("points is null");
        }
        
        for (int i = 0; i < points.length; i++) {
            if (points[i] == null) {
                throw new IllegalArgumentException("vertex at index " + i + " is null");
            }
        }
        
        this.points = points;
    }
    
    public double getPerimeter() {
        double ret = 0;
        
        for (int i = 0; i < points.length; i++) {
            Point p1 = points[i];
            Point p2 = points[(i+1)%points.length];
            ret += getLineLength(p1, p2);
        }
        
        return ret;
    }
    
    /**
     * @param p1 first point of the line segment
     * @param p2 second point of the line segment
     * @return length of the line segment, -1.0 on error
     */
    protected static double getLineLength(Point p1, Point p2) { 
        //if (p1 == null || p2 == null) {
        //    return -1.0;
        //}
        
        int dx = p1.getX() - p2.getX();
        int dy = p1.getY() - p2.getY();
        return Math.sqrt(dx * dx + dy * dy);
    }
}

















